Subject: Re: bug#22323: Font fallback causes inconsistent stacking of faces in overlays with invisible property

From: Clément Pit--Claudel <[email-masked]>
Date: Thu, 7 Jan 2016 20:19:25 -0500

On 01/07/2016 04:02 PM, Eli Zaretskii wrote:
>> Date: Thu, 07 Jan 2016 22:12:42 +0200
>> From: Eli Zaretskii <[email-masked]>
>> Cc: [email-masked]
>>
>>> The same problems exist for composition, but keeping the properties of the first character seems to work well there; maybe we could consider harmonizing both behaviors?
>>
>> I'm not sure I understand what exactly are you proposing to do.  We
>> cannot treat invisible text like we treat character compositions, each
>> one invokes a very different machinery with distinct and very
>> different features.
> 
> Here's a suggestion: ignore the face of the invisible text altogether,
> and instead always use the face of the last visible character.  The
> patch to do that is below; it fixes all of your test cases.  But since
> you would like to see the face of the invisible text show through, I'm
> not sure you will like it...
> 
> WDYT?

I like it :) I find it much more consistent that what we currently have. Plus,
has a desirable property that you pointed out and that I agree with, that the
properties of the invisible text do not affect the display of the ellipsis. The
current implementation doesn't have that property (adding a face to a hidden
character will cause the ellipsis to change to the default face), so I think
it's a net gain.

(In fact, I'm even a bit surprised that it handles the selection and font
fallback cases properly. It's great that it does though; but did I apply the
patch incorrectly?)

Clément.

> diff --git a/src/xdisp.c b/src/xdisp.c
> index 87a92fc..7e5f7df 100644
> --- a/src/xdisp.c
> +++ b/src/xdisp.c
> @@ -4583,14 +4583,15 @@ setup_for_ellipsis (struct it *it, int len)
>    it->current.dpvec_index = 0;
>    it->dpvec_face_id = -1;
>  
> -  /* Reset the current face ID to default if the last visible
> -     character and the first invisible character have different faces.
> -     IT->saved_face_id was set in handle_stop to the face of the
> -     preceding character, and will be different from IT->face_id only
> -     if the invisible text skipped in handle_invisible_prop has some
> -     non-default face.  IT's face is restored in set_iterator_to_next.  */
> -  if (it->saved_face_id < 0 || it->saved_face_id != it->face_id)
> -    it->saved_face_id = it->face_id = DEFAULT_FACE_ID;
> +  /* Use IT->saved_face_id for the ellipsis, so that it has the same
> +     face as the preceding text.  IT->saved_face_id was set in
> +     handle_stop to the face of the preceding character, and will be
> +     different from IT->face_id only if the invisible text skipped in
> +     handle_invisible_prop has some non-default face.  We thus ignore
> +     the face of the invisible text when we display the ellipsis.
> +     IT's face is restored in set_iterator_to_next.  */
> +  if (it->saved_face_id >= 0)
> +    it->face_id = it->saved_face_id;
>  
>    /* If the ellipsis represents buffer text, it means we advanced in
>       the buffer, so we should no longer ignore overlay strings.  */
> 
>